jif.extension

## Class JifCallExt

- java.lang.Object
- - polyglot.ast.Ext_c
  - - jif.ast.JifExt_c
    - - jif.extension.JifExprExt
      - - jif.extension.JifCallExt

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, JifExt, polyglot.ast.CallOps, polyglot.ast.ExprOps, polyglot.ast.Ext, polyglot.ast.NodeOps, polyglot.ast.ProcedureCallOps, polyglot.util.Copy<polyglot.ast.Ext>

      public class JifCallExt
      extends JifExprExt
      implements polyglot.ast.CallOps

  The Jif extension of the `Call` node.
  See Also:
    `Call_c`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

  - ### Field Summary

    - ### Fields inherited from class jif.ast.JifExt_c

      `toJava, X`

    - ### Fields inherited from class polyglot.ast.Ext_c

      `ext, node, pred`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JifCallExt(ToJavaExt toJava)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `constantValue(polyglot.ast.Lang lang)`
    `boolean` | `constantValueSet(polyglot.ast.Lang lang)`
    `polyglot.types.Type` | `findContainer(polyglot.types.TypeSystem ts, polyglot.types.MethodInstance mi)`
    `polyglot.types.ReferenceType` | `findTargetType()`
    `boolean` | `isConstant(polyglot.ast.Lang lang)`
    `polyglot.ast.Node` | `labelCheck(LabelChecker lc)` Label check the node to which this extension is attached.
    `polyglot.ast.Call` | `node()`
    `void` | `printArgs(polyglot.util.CodeWriter w, polyglot.visit.PrettyPrinter tr)`
    `polyglot.ast.Node` | `typeCheckNullTarget(polyglot.visit.TypeChecker tc, java.util.List<polyglot.types.Type> argTypes)`
    `protected void` | `updateContextPostTarget(LabelChecker lc, JifContext A, PathMap Xtarg)` Utility method for updating the context after checking the target.
    `protected void` | `updateContextPostTargetExpr(LabelChecker lc, JifContext A, PathMap Xtarg)` Utility method for updating the context after checking the target and it is an expression (not a Special node).

    - ### Methods inherited from class jif.extension.JifExprExt

      `getNumericBounds, setNumericBounds`

    - ### Methods inherited from class jif.ast.JifExt_c

      `checkAndRemoveThrowType, checkThrowTypes, copy, dump, getPathMap, init, integerBoundsCalculated, toJava, toJava, updatePathMap, X, X`

    - ### Methods inherited from class polyglot.ast.Ext_c

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, ext, ext, extRewrite, extRewriteEnter, extRewriteOverride, initPred, lang, pred, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, superLang, throwTypes, toString, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface polyglot.ast.Ext

      `ext, ext, initPred, pred`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewrite, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitChildren, visitList`

- - ### Constructor Detail

    - #### JifCallExt

          public JifCallExt(ToJavaExt toJava)

  - ### Method Detail

    - #### findContainer

          public polyglot.types.Type findContainer(polyglot.types.TypeSystem ts,
                                                   polyglot.types.MethodInstance mi)

      Specified by:
        `findContainer` in interface `polyglot.ast.CallOps`

    - #### labelCheck

          public polyglot.ast.Node labelCheck(LabelChecker lc)
                                       throws polyglot.types.SemanticException

      Description copied from interface: `JifExt`
      Label check the node to which this extension is attached.
      Specified by:
        `labelCheck` in interface `JifExt`
      Overrides:
        `labelCheck` in class `JifExt_c`
      Throws:
        `polyglot.types.SemanticException`

    - #### updateContextPostTarget

          protected void updateContextPostTarget(LabelChecker lc,
                                                 JifContext A,
                                                 PathMap Xtarg)

      Utility method for updating the context after checking the target. Useful for overriding in projects like fabric.

    - #### updateContextPostTargetExpr

          protected void updateContextPostTargetExpr(LabelChecker lc,
                                                     JifContext A,
                                                     PathMap Xtarg)

      Utility method for updating the context after checking the target and it is an expression (not a Special node). Useful for overriding in projects like fabric.

    - #### node

          public polyglot.ast.Call node()

      Specified by:
        `node` in interface `polyglot.ast.Ext`
      Overrides:
        `node` in class `polyglot.ast.Ext_c`

    - #### printArgs

          public void printArgs(polyglot.util.CodeWriter w,
                                polyglot.visit.PrettyPrinter tr)

      Specified by:
        `printArgs` in interface `polyglot.ast.ProcedureCallOps`

    - #### constantValueSet

          public boolean constantValueSet(polyglot.ast.Lang lang)

      Specified by:
        `constantValueSet` in interface `polyglot.ast.ExprOps`

    - #### isConstant

          public boolean isConstant(polyglot.ast.Lang lang)

      Specified by:
        `isConstant` in interface `polyglot.ast.ExprOps`

    - #### constantValue

          public java.lang.Object constantValue(polyglot.ast.Lang lang)

      Specified by:
        `constantValue` in interface `polyglot.ast.ExprOps`

    - #### findTargetType

          public polyglot.types.ReferenceType findTargetType()
                                                      throws polyglot.types.SemanticException

      Specified by:
        `findTargetType` in interface `polyglot.ast.CallOps`
      Throws:
        `polyglot.types.SemanticException`

    - #### typeCheckNullTarget

          public polyglot.ast.Node typeCheckNullTarget(polyglot.visit.TypeChecker tc,
                                                       java.util.List<polyglot.types.Type> argTypes)
                                                throws polyglot.types.SemanticException

      Specified by:
        `typeCheckNullTarget` in interface `polyglot.ast.CallOps`
      Throws:
        `polyglot.types.SemanticException`